;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Text File Format Converter
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
;##########################################################################
;##########################################################################
	FORMAT_UNIX	equ		00h
	FORMAT_DOS	equ		01h

	CurDate		TEXTEQU		<">, @Date, <">
	CurTime		TEXTEQU		<">, @Time, <">
	CurFileName	TEXTEQU		<">, @FileCur, <">
;##########################################################################
ConvertFile	PROTO	:PTR BYTE
dos2unix	PROTO
unix2dos	PROTO
ProcessCmdLine	PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szMsgAbout	db		"Text File Format Converter", 13, 10
			db		"Built on ", CurDate, " ", CurTime, 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"     http://euro.comrade64.com/", 13, 10
			db		"     http://comrade64.cjb.net/", 13, 10
			db		"     http://comrade.ownz.com/", 13, 10
			db		"     http://comrade.win32asm.com/", 13, 10
			db		"     http://comrade.hpacv.dk/", 13, 10
			db		"IRC: #coders on EFnet", 13, 10
	dwMsgAboutLen	equ		$ - szMsgAbout
	szMsgUsage	db		"  Usage: tffc.exe <option> <file mask>", 13, 10
			db		"Options: d - convert to DOS", 13, 10
			db		"         l - convert to UNIX", 13, 10
	;		db		"         m - convert to Macintosh", 13, 10
			db		"Example: tffc.exe u *.txt", 13, 10
			db		"         will convert all *.txt files in current directory into UNIX format", 13, 10
	dwMsgUsageLen	equ		$ - szMsgUsage
	szSuccessFormat	db		"Converted %s successfully!", 13, 10, 0
	szFailureFormat	db		"Failed to convert %s!", 13, 10, 0
	dwFileFormats	dd		OFFSET szFailureFormat, OFFSET szSuccessFormat
	szErrorThread	db		13, 10, "Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 13, 10, 0
	szErrorFinal	db		13, 10, "Error at %08Xh", 13, 10, "Quitting...", 13, 10, 0
	dwFormatProc	dd		OFFSET dos2unix, OFFSET unix2dos
;##########################################################################
.data
;##########################################################################
.data?
	hStdOut		dd		?
	hFind		dd		?
	hFile		dd		?
	dwFileSize	dd		?
	hMemoryFile	dd		?
	dwFile		dd		?
	szMessage	db		256 dup (?)
	seh		dd		6 dup (?)
	bFormat		db		?

	data_start	equ		$
	argc		dd		?
	argv		dd		16 dup (?)
	fd		WIN32_FIND_DATA	<>
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	GetStdHandle, STD_OUTPUT_HANDLE
	mov	[hStdOut], eax
	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	invoke	WriteFile, [hStdOut], ADDR szMsgAbout, dwMsgAboutLen, esp, 0
	; install the SEH-frame
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	; zero uninitialized data
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	edi, data_start
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	push	esi
	push	ebx
	call	ProcessCmdLine
	cmp	[argc], 3
	mov	eax, [argv+04h]		; option
	jne	@@wrar
	cmp	word ptr [eax], "u"
	mov	[bFormat], FORMAT_UNIX
	je	@@arok
	cmp	word ptr [eax], "U"
	je	@@arok
	cmp	word ptr [eax], "d"
	mov	[bFormat], FORMAT_DOS
	je	@@arok
	cmp	word ptr [eax], "D"
	je	@@arok
@@wrar:	invoke	WriteFile, [hStdOut], ADDR szMsgUsage, dwMsgUsageLen, esp, 0
	jmp	@@exit
@@arok:	invoke	FindFirstFile, [argv+08h], ADDR fd
	cmp	eax, INVALID_HANDLE_VALUE
	mov	[hFind], eax
	je	@@exit
@@next:	invoke	ConvertFile, ADDR fd.cFileName
	mov	eax, [dwFileFormats][eax*4]
	invoke	wsprintf, ADDR szMessage, eax, ADDR fd.cFileName
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0
	invoke	FindNextFile, [hFind], ADDR fd
	test	eax, eax
	jnz	@@next
@@exit:	pop	ebx
	pop	esi
	pop	edi
@@safe:	invoke	CloseHandle, [hFile]
	invoke	FindClose, [hFind]
	pop	FS:[0]
	jmp	ExitProcess
;##########################################################################
ConvertFile proc pszFileName:PTR BYTE
	invoke	CreateFile, [pszFileName], GENERIC_READ OR GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0
	mov	[hFile], eax
	inc	eax
	jz	@@done
	dec	eax
	invoke	GetFileSize, eax, 0
	mov	[dwFileSize], eax
	inc	eax
	invoke	GlobalAlloc, GMEM_MOVEABLE, eax
	mov	[hMemoryFile], eax
	invoke	GlobalLock, eax
	mov	[dwFile], eax
	push	eax	; save file buffer
	invoke	ReadFile, [hFile], [dwFile], [dwFileSize], esp, 0
	invoke	SetFilePointer, [hFile], 0, 0, FILE_BEGIN
	pop	esi	; restore file buffer
	mov	ebx, [dwFileSize]
	movzx	eax, [bFormat]
	call	[dwFormatProc][eax*4]
	invoke	SetEndOfFile, [hFile]
@@done:	push	eax
	invoke	GlobalUnlock, [hMemoryFile]
	invoke	GlobalFree, [hMemoryFile]
	invoke	CloseHandle, [hFile]
	pop	eax
	ret
ConvertFile endp
;##########################################################################
dos2unix proc
@@char:	.if word ptr [esi]==0A0Dh
		mov	byte ptr [esi], 0Ah
	.endif
	invoke	WriteFile, [hFile], esi, 1, esp, 0
	cmp	word ptr [esi], 0A0Ah
	sete	al
	add	esi, eax
	sub	ebx, eax
	inc	esi
	dec	ebx
	jnz	@@char
	ret
dos2unix endp
;##########################################################################
unix2dos proc
@@char:	.if byte ptr [esi]==0Ah
		invoke	WriteFile, [hFile], ADDR szErrorThread, 1, esp, 0
	.endif
	invoke	WriteFile, [hFile], esi, 1, esp, 0
	inc	esi
	dec	ebx
	jnz	@@char
	ret
unix2dos endp
;##########################################################################
ProcessCmdLine proc
	push	edi
	push	esi
	push	ebx
	call	GetCommandLine
	mov	esi, eax
	mov	edi, OFFSET argv
	xor	ecx, ecx
	xor	ebx, ebx
	xor	edx, edx
@@cmss:	mov	eax, esi
	mov	dl, 20h
	cmp	byte ptr [esi], 22h
	sete	cl
	lea	edx, [edx+ecx*2]
	add	eax, ecx
	stosd
@@cm00:	inc	esi
	cmp	byte ptr [esi], 0
	je	@@done
	cmp	byte ptr [esi], dl
	jne	@@cm00
	mov	byte ptr [esi], 0
	add	esi, ecx
	inc	esi
	cmp	byte ptr [esi], 0
	je	@@done
	inc	[argc]
	jmp	@@cmss
@@done:	pop	ebx
	pop	esi
	pop	edi
	inc	[argc]
	ret
ProcessCmdLine endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start